#ifndef D88_H_INCLUDED
#define D88_H_INCLUDED

#include <limits.h>

#include "pc6001v.h"


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cD88 {
private:
	// D88 ZN^\
	typedef struct{
		BYTE c;				// ID  C (V_No Жʂ̏ꍇ=gbNNo)
		BYTE h;				// ID  H (wb_AhX Жʂ̏ꍇ=0)
		BYTE r;				// ID  R (gbÑZN^No)
		BYTE n;				// ID  N (ZN^TCY 0:256 1:256 2:512 3:1024)
		WORD sec_nr;		// ̃gbNɑ݂ZN^̐
		BYTE density;		// L^x     0x00:{x   0x40:Px
		BYTE deleted;		// DELETED MARK 0x00:m[} 0x10:DELETED
		BYTE status;		// Xe[^X
		BYTE reserve[5];	// U[u
		WORD size;			// ̃ZN^̃f[^TCY
		DWORD data;			// f[^ւ̃ItZbg
		WORD offset;		// ɓǍރf[^̃ZN^擪̃ItZbg
	} D88SECTOR;
	
	// D88 \
	typedef struct{
		BYTE name[17];		// fBXN̖O(ASCII + '\0')
		BYTE reserve[9];	// U[u
		BYTE protect;		// CgveNg  0x00:Ȃ 0x10:
		BYTE type;			// fBXN̎    0x00:2D   0x10:2DD  0x20:2HD
		DWORD size;			// fBXÑTCY(wb_+SgbN)
		DWORD table[164];	// gbÑItZbge[u(Track 0-163)
		D88SECTOR secinfo;	// ZN^
		FILE *fp;			// FILE |C^
	} D88INFO;
	
	D88INFO d88;				// D88 
	char FileName[PATH_MAX];	// t@Cobt@
	
	BOOL Protected;				// veNgV[
	
	void ReadHeader88();		// D88 wb_Ǎ
	void ReadSector88();		// D88 ZN^Ǎ
	
public:
	cD88();						// RXgN^
	~cD88();					// fXgN^
	
	BOOL Init( char * );		// 
	
	BYTE Getc88();				// 1byte Ǎ
	BOOL Putc88( BYTE );		// 1byte 
	BOOL Seek88( int, int );	// V[N
	DWORD GetCHRN();			// ݂CHRN擾
	
	char *GetFileName();		// t@C擾
	char *GetDiskImgName();		// DISKC[W擾
	BOOL IsProtect();			// veNgV[Ԏ擾
};

#endif	// D88_H_INCLUDED
