#ifndef Z80_H_INCLUDED
#define Z80_H_INCLUDED

#include <SDL_endian.h>

#include "pc6001v.h"
#include "ini.h"

#include "p6device.h"


// yAWX^ f[^^`
typedef union {
#if SDL_BYTEORDER == SDL_BIG_ENDIAN
 	struct { BYTE h,l; } B;
#else
	struct { BYTE l,h; } B;
#endif
			 WORD        W;
} PAIR;

// WX^Q \̒`
struct Register {
	PAIR AF, BC, DE, HL;	// ėpWX^
	PAIR IX, IY, PC, SP;	// pWX^
	PAIR AF1,BC1,DE1,HL1;	//   WX^
	BYTE I, R;				// ꃌWX^
	BYTE R_saved;			// R reg ۑp
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// [h
	BYTE Halt;				// HALT tO
};


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class cz80 : public IDoko {
protected:
	typedef signed char	offset;
	
	PAIR AF, BC, DE, HL;	// ėpWX^
	PAIR IX, IY, PC, SP;	// pWX^
	PAIR AF1,BC1,DE1,HL1;	//   WX^
	BYTE I, R;				// ꃌWX^
	BYTE R_saved;			// R reg ۑp
	BYTE IFF,IFF2;			// IFF,IFF2
	BYTE IM;				// [h
	BYTE Halt;				// HALT tO
	
	int mstate;				// ANZXEFCg Xe[g
	
	// tFb`(M1)
	virtual BYTE Fetch( WORD, int * )   = 0;
	
	// ANZX(EFCgȂ)
	virtual BYTE ReadMemNW( WORD )      = 0;
	
	// ANZX(EFCg)
	virtual BYTE ReadMem( WORD )        = 0;
	virtual void WriteMem( WORD, BYTE ) = 0;
	
	// I/O|[gANZX
	virtual BYTE ReadIO( int )          = 0;
	virtual void WriteIO( int, BYTE )   = 0;
	
	// ݃xN^擾
	virtual int GetIntrVector()         = 0;
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	void PrintfHead( char *, WORD, int );	// AhX/CXgNVR[h̕\
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
public:
	cz80();						// RXgN^
	virtual ~cz80();			// fXgN^
	
	void Reset();				// Zbg
	int Exec();					// 1ߎs
	
	void AddWait( int );		// EFCgǉ
	
	#ifdef USEMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	// fobOp
	int Disasm( char *, WORD );		// 1CtAZu
	void GetRegister( Register * );	// WX^l擾
	void SetRegister( Register * );	// WX^lݒ
	WORD GetPC(){ return PC.W; }	// PCWX^l擾
	#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
	
	// ------------------------------------------
	BOOL DokoSave( cIni * );	// ǂłSAVE
	BOOL DokoLoad( cIni * );	// ǂłLOAD
	// ------------------------------------------
};


class CPU6 : public P6DEVICE, public cz80 {
private:
	// tFb`(M1)
	inline BYTE Fetch( WORD, int * );
	
	// ANZX(EFCgȂ)
	inline BYTE ReadMemNW( WORD );
	
	// ANZX(EFCg)
	inline BYTE ReadMem( WORD );
	inline void WriteMem( WORD, BYTE );
	
	// I/O|[gANZX
	inline BYTE ReadIO( int );
	inline void WriteIO( int, BYTE );
	
	// ݃xN^擾
	inline int GetIntrVector();
	
public:
	CPU6( VM6 *, const P6ID& );	// RXgN^
	~CPU6();					// fXgN^
	
	BOOL Init();				// 
};

#endif		// Z80_H_INCLUDED
